%code requires {
	// define here any types required in the %union directive	
}

%code {
	#include <cstdio>
	#include <iostream>	
	int yylex();

	extern FILE* yyin;

	void yyerror(const char* error) {
		std::cout << error << std::endl;
	}
}

%union {
	int intValue;
}

%start input

%token<intValue> INTEGER
%type<intValue> term fact

%%

input : line
	| input line
	;

line : term ';' {
		std::cout << "==> " << $1 << std::endl;
	}
	;

term : term '+' fact {
		$$ = $1 + $3;
	}
	| fact {
		$$ = $1;
	}
	;

fact : fact '*' INTEGER {
		$$ = $1 * $3;
	}
	| INTEGER {
		$$ = $1;
	}
	;

%%

int main(int argc, char** argv) {
	if(argc != 2) {
		std::cout << "Usage: ./calc <input-file>" << std:: endl;
		return 1;
	}

	yyin = fopen(argv[1], "r");
	if(!yyin) {
		std::cout << "Error opening file " << argv[1] << std:: endl;
		return 1;
	}

	yyparse();
	return 0;
}
